/*###########################################################################
#                                                                           #
#                    Arduino Ethernet Shield 䃂W[                 #
#                                                            				#
###########################################################################*/
#define __AES_C__

/* SPI|[g`					*/
#define SPI_TYPE 1					/* 0:soft 1:SPIport 2:USART0 3:USART1	*/

#define SPI_MOSI_PORT PORTB			/* MOSIɊ蓖Ă|[g̏o̓WX^	*/
#define SPI_MOSI_BIT  3				/* MOSIɊ蓖Ă|[g̃rbgԍ	*/

#define SPI_MISO_PIN  PINB			/* MISOɊ蓖Ă|[g̓̓WX^	*/
#define SPI_MISO_BIT  4				/* MISOɊ蓖Ă|[g̃rbgԍ	*/

#define SPI_SCK_PORT PORTB			/* SCKɊ蓖Ă|[g̏o̓WX^	*/
#define SPI_SCK_BIT  5				/* SCKɊ蓖Ă|[g̃rbgԍ	*/

/* #CSiύXj				*/
#define AES_ENABLE_CS()		( PORTB &= ~_BV(2) )
#define AES_DISABLE_CS()	( PORTB |=  _BV(2) )

/* #RESETiύXj				*/
#define AES_ENABLE_RESET()	( PORTC &= ~_BV(5) )
#define AES_DISABLE_RESET()	( PORTC |=  _BV(5) )

/* ʃWX^AhX`			*/
#define MR				( 0x0000 )		/* Mode Register										*/
#define GWR				( 0x0001 )		/* Gateway IP Address Register							*/
#define SUBR			( 0x0005 )		/* Subnet Mask Register									*/
#define SHAR			( 0x0009 )		/* Source Hardware Address Register 					*/
#define SIPR			( 0x000f )		/* Source IP Address Register							*/
#define RMSR			( 0x001a )		/* RX Memory Size Register								*/
#define TMSR			( 0x001b )		/* TX Memory Size Register								*/

/* \PbgWX^ItZbg`	*/
#define Sn_MR			( 0x0000 )		/* Socket n Mode										*/
#define Sn_CR			( 0x0001 )		/* Socket n Command										*/
#define Sn_SR			( 0x0003 )		/* Socket n Status										*/
#define Sn_PORT			( 0x0004 )		/* Socket n Source Port									*/
#define Sn_DIPR			( 0x000c )		/* Socket n Destination IP Address						*/
#define Sn_DPORT		( 0x0010 )		/* Socket n Destination Port							*/
#define Sn_PROTO		( 0x0014 )		/* Socket n IP Protocol									*/
#define Sn_TX_FSR		( 0x0020 )		/* Socket n Transmit free memory size					*/
#define Sn_TX_WR		( 0x0024 )		/* Socket n Transmit memory write pointer				*/
#define Sn_RX_RSR		( 0x0026 )		/* Socket n Received data size							*/
#define Sn_RX_RD		( 0x0028 )		/* Socket n Read point of Receive memory				*/

/* Sn_CR p[^`				*/
#define Sn_CR_OPEN		( 0x01 )		/* initialize or open socket							*/
#define Sn_CR_LISTEN	( 0x02 )		/* wait connection request in tcp mode(Server mode)		*/
#define Sn_CR_CONNECT	( 0x04 )		/* send connection request in tcp mode(Client mode)		*/
#define Sn_CR_DISCON	( 0x08 )		/* send closing reqeuset in tcp mode 					*/
#define Sn_CR_CLOSE		( 0x10 )		/* close socket 										*/
#define Sn_CR_SEND		( 0x20 )		/* updata txbuf pointer, send data 						*/
#define Sn_CR_SEND_MAC	( 0x21 )		/* send data with MAC address, so without ARP process	*/
#define Sn_CR_SEND_KEEP	( 0x22 )		/* send keep alive message								*/
#define Sn_CR_RECV		( 0x40 ) 		/* update rxbuf pointer, recv data 						*/

/* [hWX^p[^`		*/
#define MR_RST			( 0x80 )		/* S/W Reset 											*/
#define MR_PB			( 0x10 )		/* Ping Block Mode 										*/

/* ewb_t@C荞		*/
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "util/delay.h"
#include "aes.h"
#include "spi_func.h"

#include <stdio.h>
#include "soft_usart.h"

/* EGCg}N`				*/
#define WAIT_MS(tim) { uint16_t cnt = (uint16_t)(tim); while ( cnt-- ) { _delay_ms( 1 ); } }

/* [J֐vg^Cv錾		*/
static void aesWriteByte( uint16_t addr ,uint8_t data );
static uint8_t aesReadByte( uint16_t addr );
static void aesWriteWord( uint16_t addr ,uint16_t data );
static uint16_t aesReadWord( uint16_t addr );
static void aesWriteBlock( uint16_t addr ,uint8_t *data ,uint16_t len );
static void aecTransmissionPreparation( uint8_t sok );

/* [Jϐ錾					*/
static const prog_uint16_t sokRegBase[] = { 0x400 ,0x0500 ,0x0600 ,0x0700 };
static AES_SYSTEM *_es;

/*****************************************************************************
*						Arduino Ethernet Shield 
* FAES_SYSTEM *es p[^
* ߒlFvoid
*****************************************************************************/
void aesInit( AES_SYSTEM *es )
{
	uint8_t msr;
	uint8_t i;
	uint16_t free;
	uint16_t addr;

	spiInit();									/* SPI							*/
	SPI_HI_SPEED();

	AES_ENABLE_RESET();							/* n[hEGAZbg					*/
	WAIT_MS( 10 );
	AES_DISABLE_RESET();
	WAIT_MS( 10 );
	aesWriteByte( MR ,MR_RST );					/* \tgEGAZbg					*/
	WAIT_MS( 10 );

	aesWriteBlock( SHAR ,es->mac ,6 );			/* MACAhXݒ						*/
	aesWriteBlock( SIPR ,es->ip ,4 );			/* IPAhXݒ						*/
	aesWriteBlock( GWR ,es->gateway ,4 );		/* Q[gEGCAhXݒ				*/
	aesWriteBlock( SUBR ,es->subnet ,4 );		/* Tulbg}XNݒ					*/

	/* e\PbgMobt@	*/
	addr = 0x4000;								/* Mobt@̕AhX			*/
	free = 8192;								/* Mobt@̋					*/
	msr = 0x00;
	for ( i = 0 ;i < 4 ;i++ ) {
		if ( ( es->sok[i].txSize != 8192 ) && ( es->sok[i].txSize != 4096 ) && ( es->sok[i].txSize != 2048 ) && ( es->sok[i].txSize != 1024 ) ) {
		 	es->sok[i].txSize = 1024;
		}

		if ( free < es->sok[i].txSize ) {
			es->sok[i].txSize = free;
		}

		msr >>= 2;
		if ( es->sok[i].txSize == 8192 ) {
			msr |= 0xc0;
		} else if ( es->sok[i].txSize == 4096 ) {
			msr |= 0x80;
		} else if ( es->sok[i].txSize == 2048 ) {
			msr |= 0x40;
		}

		es->sok[i].txFlag = 0;
		es->sok[i].txMask = 0;
		es->sok[i].txTopAddress = 0;
		if ( es->sok[i].txSize ) {
			es->sok[i].txMask = es->sok[i].txSize - 1;
			es->sok[i].txTopAddress = addr;
			addr += es->sok[i].txSize;
		}
	}
	aesWriteByte( TMSR ,msr );

	/* e\PbgMobt@ݒ	*/
	addr = 0x6000;								/* Mobt@̕AhX			*/
	free = 8192;								/* Mobt@̋					*/
	msr = 0x00;
	for ( i = 0 ;i < 4 ;i++ ) {
		if ( ( es->sok[i].rxSize != 8192 ) && ( es->sok[i].rxSize != 4096 ) && ( es->sok[i].rxSize != 2048 ) && ( es->sok[i].rxSize != 1024 ) ) {
		 	es->sok[i].rxSize = 1024;
		}

		if ( free < es->sok[i].rxSize ) {
			es->sok[i].rxSize = free;
		}

		msr >>= 2;
		if ( es->sok[i].rxSize == 8192 ) {
			msr |= 0xc0;
		} else if ( es->sok[i].rxSize == 4096 ) {
			msr |= 0x80;
		} else if ( es->sok[i].rxSize == 2048 ) {
			msr |= 0x40;
		}

		es->sok[i].rxMask = 0;
		es->sok[i].rxTopAddress = 0;
		if ( es->sok[i].rxSize ) {
			es->sok[i].rxMask = es->sok[i].rxSize - 1;
			es->sok[i].rxTopAddress = addr;
			addr += es->sok[i].rxSize;
		}
	}
	aesWriteByte( RMSR ,msr );

	_es = es;
}

/*****************************************************************************
*					NCAg[hŃ\PbgڑJn
* Fuint8_t  sok   \Pbgԍ
*		SOK_MODE mode  \Pbg[h
*		uint8_t  *ip   ڑT[o[IPAhX
*		uint16_t port  ڑT[o[̃|[gԍ
*		uint8_t  proto vgRԍ( 6:TCP  17:UDP ... )
*       uint8_t  wait  0:ڑ҂sȂ
*					   1:ڑ҂s(^CAEg10b)
* ߒlFuint8_t        0:OK !0:NG
*
* TCP/UDP̂ݓmFς݁B
*****************************************************************************/
uint8_t aesConnectClient( uint8_t sok ,SOK_MODE mode ,uint8_t *ip ,uint16_t port ,uint8_t proto ,uint8_t wait )
{
	static uint16_t sport = 1;						/* |[gԍp	*/
	uint8_t n;
	uint8_t sts;
	uint8_t ret;
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );

	/* gp̃|[gԍ					*/
	do {
		sport = ( sport + 1 ) | 0x8000;

		n = AES_SOCKET_COUNT;
		while ( n-- ) {
			uint8_t sts = aesReadByte( bs + Sn_SR );
			if ( sts != SOK_CLOSED ) {
				uint16_t s = aesReadWord( bs + Sn_PORT  );
				uint16_t d = aesReadWord( bs + Sn_DPORT );
				if ( ( sport == s ) || ( sport == d ) || ( sport == port ) ) {
					break;
				}
			}
		}
	} while ( n != 0xff );

	/* ep[^ޔ						*/
	memcpy( _es->sok[sok].ip ,ip ,4 );
	_es->sok[sok].port = port;
	_es->sok[sok].sport = sport;
	_es->sok[sok].proto = proto;
	_es->sok[sok].mode = mode;
	_es->sok[sok].txFlag = 0;

	/* \PbgI[v							*/
	aesCloseSocket( sok );
	aesWriteByte(  bs + Sn_MR    ,mode );
	aesWriteWord(  bs + Sn_PORT  ,sport );
	aesWriteWord(  bs + Sn_PROTO ,proto );
	aesWriteByte( bs + Sn_CR ,Sn_CR_OPEN );
	while( aesReadByte( bs + Sn_CR ) );

	/* \PbgXe[^XmF					*/
	ret = 0;
	sts = aesGetSocketStatus( sok );
	n = mode & 0x0f;
	if ( n == MR_UDP ) {
		if ( sts != SOK_UDP ) {
			ret = 1;
		}
	} else if ( n == MR_TCP ) {
		if ( sts != SOK_INIT ) {
			ret = 2;
		}
	}

	/* Xe[^XG[̏ꍇ̓N[YďI	*/
	if ( ret ) {
		aesCloseSocket( sok );
		return ( ret );
	}

	/* UDP\Pbg̏ꍇ͂ŏI			*/
	if ( n == MR_UDP ) {
		return ( ret );
	}

	sts = 0;
	n = 250;			/* timeout 10sec	*/
	do {

		/* \PbgڑJn					*/
		aesWriteBlock( bs + Sn_DIPR  ,ip ,4 );
		aesWriteWord(  bs + Sn_DPORT ,port );
		aesWriteByte( bs + Sn_CR ,Sn_CR_CONNECT );
		while( aesReadByte( bs + Sn_CR ) );

		/* \Pbgڑ҂					*/
		if ( wait ) {
			do {
				sts = aesGetSocketStatus( sok );
				if ( ( sts == SOK_ESTABLISHED ) || ( sts == SOK_CLOSED ) || ( sts == SOK_SYNRECV ) ) {
					break;
				}
				WAIT_MS( 40 );
			} while ( --n );
		}

	} while ( wait && n && ( sts != SOK_ESTABLISHED ) );

	/* \PbgԊmF						*/
	if ( wait ) {
		if ( sts == SOK_ESTABLISHED ) {
			sts = 0;
		} else {
			aesCloseSocket( sok );
			sts = 1;
		}
	} else {
		sts = 0;
	}

	return ( sts );
}

/*****************************************************************************
*							\Pbg̐ڑԎ擾
* Fuint8_t sok \Pbgԍ
* ߒlFSOK_STATUS  Xe[^X
*****************************************************************************/
SOK_STATUS aesGetSocketStatus( uint8_t sok )
{
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );
	return ( aesReadByte( bs + Sn_SR ) );
}

/*****************************************************************************
*							\Pbg̃N[Y
* Fuint8_t sok \Pbgԍ
* ߒlFvoid
*****************************************************************************/
void aesCloseSocket( uint8_t sok )
{
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );
	aesWriteByte( bs + Sn_CR ,Sn_CR_CLOSE );
	while( aesReadByte( bs + Sn_CR ) );
	_es->sok[sok].txFlag = 0;
}

/*****************************************************************************
*				w\Pbg̑Mobt@փf[^
* Fuint8_t  sok   \Pbgԍ
*		void     *data ݃f[^
*		uint16_t len   f[^
* ߒlFvoid
* Mobt@I[o[t[͍̏sȂ
*****************************************************************************/
void aesWriteTxBuffer( uint8_t sok ,void *data ,uint16_t len )
{
	uint16_t addr;
	uint8_t *p = (uint8_t *)data;

	/* M							*/
	aecTransmissionPreparation( sok );

	/* Mobt@֏			*/
	while ( len-- ) {
		addr = _es->sok[sok].txTopAddress + ( _es->sok[sok].txWp & _es->sok[sok].txMask );
		aesWriteByte( addr ,*p++ );
		_es->sok[sok].txWp++;
	}
}

/*****************************************************************************
*				w\Pbg̑Mobt@փf[^
* Fuint8_t    sok    \Pbgԍ
*		prog_void *data   ݃f[^
*		uint16_t   len    f[^
* ߒlFvoid
* Mobt@I[o[t[͍̏sȂ
*****************************************************************************/
void aesWriteTxBuffer_P( uint8_t sok ,prog_void *data ,uint16_t len )
{
	prog_uint8_t *p = (prog_uint8_t *)data;
	uint16_t addr;

	/* M							*/
	aecTransmissionPreparation( sok );

	/* Mobt@֏			*/
	while ( len-- ) {
		addr = _es->sok[sok].txTopAddress + ( _es->sok[sok].txWp & _es->sok[sok].txMask );
		aesWriteByte( addr ,pgm_read_byte( p++ ) );
		_es->sok[sok].txWp++;
	}
}

/*****************************************************************************
*				w\Pbg̑Mobt@֕
* Fuint8_t  sok   \Pbgԍ
*		char     *str  ݕ
* ߒlFvoid
* Mobt@I[o[t[͍̏sȂ
*****************************************************************************/
void aesStrWriteTxBuffer( uint8_t sok ,char *str )
{
	uint16_t addr;

	/* M							*/
	aecTransmissionPreparation( sok );

	/* Mobt@֏			*/
	while ( *str ) {
		addr = _es->sok[sok].txTopAddress + ( _es->sok[sok].txWp & _es->sok[sok].txMask );
		aesWriteByte( addr ,*str++ );
		_es->sok[sok].txWp++;
	}
}

/*****************************************************************************
*				w\Pbg̑Mobt@֕
* Fuint8_t    sok    \Pbgԍ
*		prog_char *str    ݕ
* ߒlFvoid
* Mobt@I[o[t[͍̏sȂ
*****************************************************************************/
void aesStrWriteTxBuffer_P( uint8_t sok ,prog_char *str )
{
	uint16_t addr;

	/* M							*/
	aecTransmissionPreparation( sok );

	/* Mobt@֏			*/
	while ( pgm_read_byte( str ) ) {
		addr = _es->sok[sok].txTopAddress + ( _es->sok[sok].txWp & _es->sok[sok].txMask );
		aesWriteByte( addr ,pgm_read_byte( str++ ) );
		_es->sok[sok].txWp++;
	}
}

/*****************************************************************************
*				w\Pbg̑Mobt@̋󂫗eʂ擾
* Fuint8_t  sok   \Pbgԍ
* ߒlFuint16_t       󂫗e
*****************************************************************************/
uint16_t aesGetTxFree( uint8_t sok )
{
	return ( aesReadWord( pgm_read_word( &sokRegBase[sok] ) + Sn_TX_FSR ) );
}

/*****************************************************************************
*			w\Pbg̑Mobt@̃f[^𑗐M
* Fuint8_t  sok   \Pbgԍ
* ߒlFvoid
*****************************************************************************/
void aesSendProcessTx( uint8_t sok )
{
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );
	if ( _es->sok[sok].txFlag ) {
		aesWriteWord( bs + Sn_TX_WR ,_es->sok[sok].txWp );
		aesWriteByte( bs + Sn_CR ,Sn_CR_SEND );
		while( aesReadByte( bs + Sn_CR ) );
		_es->sok[sok].txFlag = 0;
	}
}

/*****************************************************************************
*				w\Pbg̎Mobt@f[^擾
* Fuint8_t  sok   \Pbgԍ
*		void     *data Mf[^i[obt@
*		uint16_t len   obt@TCY
* ߒlFuint16_t       擾f[^
*****************************************************************************/
uint16_t aesReadRdBuffer( uint8_t sok ,void *data ,uint16_t len )
{
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );
	uint16_t rp = aesReadWord( bs + Sn_RX_RD );			/* Mobt@[h|C^	*/
	uint16_t recvLen = aesReadWord( bs + Sn_RX_RSR );	/* Mobt@f[^		*/
	uint8_t *p = (uint8_t *)data;
	uint16_t addr;
	uint16_t ret = 0;

	if ( recvLen && len ) {

		/* Mf[^擾			*/
		while ( recvLen && len ) {
			addr = _es->sok[sok].rxTopAddress + ( rp & _es->sok[sok].rxMask );
			*p++ = aesReadByte( addr );
			rp++;
			recvLen--;
			len--;
			ret++;
		}

		/* [h|C^XV		*/
		aesWriteWord( bs + Sn_RX_RD ,rp );

		/* MR}h				*/
		aesWriteByte( bs + Sn_CR ,Sn_CR_RECV );
		while( aesReadByte( bs + Sn_CR ) );
	}

	return ( ret );
}

/*****************************************************************************
*				w\Pbg̎Mobt@當Ps擾
* Fuint8_t  sok   \Pbgԍ
*		char *str      Mf[^i[obt@
*		char ch        s̏IR[h
*		uint16_t len   obt@TCY
* ߒlFuint16_t       擾(0:TimeOut)
*****************************************************************************/
uint16_t aesStrReadRdBuffer( uint8_t sok ,char *str ,char ch ,uint16_t len )
{
	uint8_t c;
	uint8_t timeOut = 50;
	uint16_t n = 0;
	while ( timeOut-- ) {
		if ( aesGetRdCount( sok ) == 0 ) {
			WAIT_MS( 100 );
			continue;
		}

		timeOut = 20;
		aesReadRdBuffer( sok ,&c ,1 );
		if ( ( n + 1 ) < len ) {
			n++;
			*str++ = c;
		}

		if ( c == ch ) {
			break;
		}
	}

	*str = '\0';
	return ( n );
}

/*****************************************************************************
*				Mobt@̃f[^nȏɂȂ܂ő҂
* Fuint8_t  sok \Pbgԍ
*		uint16_t n   f[^
* ߒlFuint8_t      0:OK !0:NG
*****************************************************************************/
uint8_t aesWaitReceive( uint8_t sok ,uint16_t n )
{
	uint8_t timeOut = 50;						/* time out 5sec			*/
	while ( timeOut-- ) {
		if ( aesReadWord( pgm_read_word( &sokRegBase[sok] ) + Sn_RX_RSR ) >= n ) {
			return ( 0 );
		}
		WAIT_MS( 100 );
	}
	return ( 1 );
}

/*****************************************************************************
*				w\Pbg̎Mobt@̃f[^擾
* Fuint8_t  sok \Pbgԍ
* ߒlFuint16_t     f[^
*****************************************************************************/
uint16_t aesGetRdCount( uint8_t sok )
{
	return ( aesReadWord( pgm_read_word( &sokRegBase[sok] ) + Sn_RX_RSR ) );
}

/*****************************************************************************
*							hCIPAhXɕϊ
* Fuint8_t sok   gp\Pbgԍ
*       char *name    ₢킹hCl[
*		uint8_t *ans  DNS񓚂ꂽIPAhX
* ߒlFuint8_t       0:OK !0:NG
* pPbglȉ񓚂ɂ͖ΉΉ
*   啔̃f[^̓`FbNĂȂ
*   ̉񓚂Lꍇ͍ŏ̗Lȉ񓚂Ԃ
****************************************************************************/
uint8_t aesDnsRequest( uint8_t sok ,char *name ,uint8_t *ans )
{
	static prog_uint8_t hd[] = { 0x01 ,0x00 ,0x00 ,0x01 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 };
	static prog_uint8_t ft[] = { 0x00 ,0x00 ,0x01 ,0x00 ,0x01 };
	static uint16_t sn = 0x8000;							/* ʃR[hۑp			*/

	char *p1;
	char *p2;
	uint8_t data[14];
	uint8_t ret;
	uint8_t retryCnt;
	uint16_t n;
	uint16_t anCount;										/* 񓚃R[h			*/
	uint16_t qLen;											/* f[^				*/

	memset( ans ,0x00 ,4 );

	ret = 0xff;
	retryCnt = 5;											/* gC 5				*/
	while ( retryCnt-- ) {

		if ( retryCnt != 4 ) {								/* gC̏			*/
			WAIT_MS( 1000 );
			aesCloseSocket( sok );
		}

		/* DNST[o[UDP|[g53֐ڑ			*/
		if ( aesConnectClient( sok ,MR_UDP ,_es->dns ,53 ,17 ,0 ) != 0 ) {
			continue;
		}

		/* ʎq𑗐Mobt@ɏ				*/
		sn = ( sn + 1 ) | 0x8000;
		aesWriteTxBuffer( sok ,&sn ,2 );

		/* wb_Œf[^𑗐Mobt@ɏ	*/
		memcpy_P( data ,hd ,sizeof(hd) );
		aesWriteTxBuffer( sok ,data ,sizeof(hd) );

		/* '://' ǂݔ΂						*/
		p1 = p2 = name;
		while ( strlen( p2 ) >= 3 ) {
			if ( strncmp_P( p2 ,PSTR("://") ,3 ) == 0 ) {
				p1 = ( p2 + 3 );
				break;
			}
			p2++;
		}

		/* ₢킹hC𑗐Mobt@ɏ	*/
		qLen = 0;
		do {
			n = 0;
			p2 = p1;
			while ( ( ( *p2 >= '0' ) && ( *p2 <= '9' ) ) || ( ( *p2 >= 'A' ) && ( *p2 <= 'Z' ) ) || ( ( *p2 >= 'a' ) && ( *p2 <= 'z' ) ) || ( *p2 == '-' ) ) {
				n++;
				p2++;
			}

			if ( n > 255 ) {
				break;

			} else if ( n ) {
				aesWriteTxBuffer( sok ,&n ,1 );
				aesWriteTxBuffer( sok ,p1 ,n );
				p1 = p2 + 1;
				qLen += (n + 1 );
			}

		} while ( *p2 == '.' );

		if ( ( n > 255 ) || ( qLen == 0 ) ) {
			ret = 0x10;
			break;
		}

		/* tb^Œf[^𑗐Mobt@ɏ	*/
		memcpy_P( data ,ft ,sizeof(ft) );
		aesWriteTxBuffer( sok ,data ,sizeof(ft) );
		qLen += sizeof(ft);

		/* Mobt@̃f[^𑗐Ms			*/
		aesSendProcessTx( sok );

		/* Mobt@8oCg擾				*/
		if ( aesWaitReceive( sok ,8 ) != 0 ) {				/* W5100UDPwb_擾			*/
			continue;
		}
		aesReadRdBuffer( sok ,data , 8 );
		
		/* IPAhX`FbN						*/
		if ( memcmp( &data[0] ,_es->dns ,4 ) != 0 ) {		/* sv						*/
			continue;
		}				

		/* |[gԍ`FbN						*/
		if ( ( data[4] != 0 ) || ( data[5] != 53 ) ) {		/* |[gԍsv(!53)		*/
			continue;
		}				

		/* f[^`FbN							*/
		n = ( (uint16_t)data[6] << 8 ) | (uint16_t)data[7];
		if ( n < 12 ) {										/* f[^Z				*/
			continue;
		}				

		if ( aesGetRdCount( sok ) != n ) {					/* Mf[^sv			*/
			continue;
		}				

		/* Mobt@12oCg擾				*/
		if ( aesWaitReceive( sok ,12 ) != 0 ) {				/* DNSwb_擾				*/
			continue;
		}
		aesReadRdBuffer( sok ,data , 12 );

		/* ʎq`FbN							*/
		n = (uint16_t)data[0] | ( (uint16_t)data[1] << 8 );
		if ( sn != n ) {									/* sv						*/
			continue;
		}				

		/* etO`FbN						*/
		n = ( (uint16_t)data[2] << 8 ) | (uint16_t)data[3];

		if ( ( n & 0x000f ) != 0 ) {						/* ^[R[hNG ?			*/
			ret = (uint8_t)( n & 0x000f );
			break;
		}

		if ( ( n & 0xfbf0 ) != 0x8180 ) {					/* tONG						*/
			continue;
		}

		/* QDCOUNT `FbN							*/
		n = ( (uint16_t)data[4] << 8 ) | (uint16_t)data[5];
		if ( n != 1 ) {
			continue;
		}

		/* NSCOUNTiЃR[hj `FbN		*/
		n = ( (uint16_t)data[8] << 8 ) | (uint16_t)data[9];
		if ( n != 0 ) {
			continue;
		}

		/* ARCOUNTiǉR[hj `FbN		*/
		n = ( (uint16_t)data[10] << 8 ) | (uint16_t)data[11];
		if ( n != 0 ) {
			continue;
		}

		/* ANCOUNTi񓚃R[hj`FbN		*/
		anCount = ( (uint16_t)data[6] << 8 ) | (uint16_t)data[7];
		if ( anCount == 0 ) {
			continue;
		}

		/* f[^ǂݎ̂āi蔲j				*/
		while ( qLen-- ) {
			while ( !aesReadRdBuffer( sok ,data ,1 ) );
		}

		/* ANCOUNT̕[v					*/
		while ( anCount-- ) {

			/* 񓚃R[hl[ǂݎ̂(蔲j	*/
			if ( aesWaitReceive( sok ,1 ) != 0 ) {
				continue;
			}
			aesReadRdBuffer( sok ,data , 1 );

			if ( data[0] >= 0xc0 ) {
				n = 1;
			} else {
				n = (uint16_t)data[0];
			}

			if ( aesWaitReceive( sok ,n ) != 0 ) {			/* time out						*/
				continue;
			}

			while ( n-- ) {
				aesReadRdBuffer( sok ,data , 1 );
			}

			if ( aesWaitReceive( sok ,10 ) != 0 ) {			/* time out						*/
				continue;
			}
			aesReadRdBuffer( sok ,data , 10 );

			/* RDATAŎꂽf[^M܂ő҂	*/
			n = ( (uint16_t)data[8] << 8 ) | (uint16_t)data[9];		/* RDATA				*/
			if ( aesWaitReceive( sok ,n ) != 0 ) {			/* time out						*/
				continue;
			}

			/* TYPE = 1 / CLASS = 1 ̏ꍇIPAhX擾	*/
			if ( ( data[0] == 0x00 ) && ( data[1] == 0x01 ) && ( data[2] == 0x00 ) && ( data[3] == 0x01 ) && ( n == 4 ) ) {
				aesReadRdBuffer( sok ,ans , 4 );
				if ( ( ans[0] != 0x00 ) || ( ans[1] != 0x00 ) || ( ans[2] != 0x00 ) || ( ans[3] != 0x00 ) ) {
					retryCnt = 0;
					ret = 0;
					break;
				}
			} else {
				/* RDATAŎꂽf[^ǂݎ̂āi蔲j*/
				while ( n-- ) {
					aesReadRdBuffer( sok ,data , 1 );
				}
			}
		}
	}

	aesCloseSocket( sok );
	return ( ret );
}

/*****************************************************************************
*								1oCg
* Fuint16_t addr AhX
*       uint8_t  data f[^
* ߒlFvoid
*****************************************************************************/
static void aesWriteByte( uint16_t addr ,uint8_t data )
{
	AES_ENABLE_CS();
	spiTransfer( 0xf0 );
	spiTransfer( (uint8_t)( addr >> 8 ) );
	spiTransfer( (uint8_t)( addr & 0x00ff ) );
	spiTransfer( data );
	AES_DISABLE_CS();
}

/*****************************************************************************
*								1oCgǍ
* Fuint16_t addr AhX
* ߒlFuint8_t       f[^
*****************************************************************************/
static uint8_t aesReadByte( uint16_t addr )
{
	AES_ENABLE_CS();
	spiTransfer( 0x0f );
	spiTransfer( (uint8_t)( addr >> 8 ) );
	spiTransfer( (uint8_t)( addr & 0x00ff ) );
	uint8_t data = spiTransfer( 0xff );
	AES_DISABLE_CS();
	return ( data );
}

/*****************************************************************************
*								[h
* Fuint16_t addr AhX
*       uint16_t data f[^
* ߒlFvoid
*****************************************************************************/
static void aesWriteWord( uint16_t addr ,uint16_t data )
{
	aesWriteByte( addr     ,(uint8_t)( data >> 8 ) );
	aesWriteByte( addr + 1 ,(uint8_t)( data & 0x00ff ) );
}

/*****************************************************************************
*								[hǍ
* Fuint16_t addr AhX
* ߒlFuint16_t      f[^
*****************************************************************************/
static uint16_t aesReadWord( uint16_t addr )
{
	uint16_t data;
	data = (uint16_t)aesReadByte( addr ) << 8;
	data |= aesReadByte( addr + 1 );
	return ( data );
}

/*****************************************************************************
*								ubN
* Fuint16_t addr AhX
*       uint8_t *data obt@
*		uint16_t len  f[^
* ߒlFvoid
*****************************************************************************/
static void aesWriteBlock( uint16_t addr ,uint8_t *data ,uint16_t len )
{
	while ( len-- ) {
		aesWriteByte( addr++ ,*data++ );
	}
}

/*****************************************************************************
*						Mobt@֏ޏs
* Fuint8_t  sok  \Pbgԍ
* ߒlFvoid
*****************************************************************************/
static void aecTransmissionPreparation( uint8_t sok )
{
	uint16_t bs = pgm_read_word( &sokRegBase[sok] );

	/* Mobt@̃Cg|C^擾	*/
	if ( _es->sok[sok].txFlag == 0 ) {
		_es->sok[sok].txWp = aesReadWord( bs + Sn_TX_WR );
		_es->sok[sok].txFlag = 1;

		/* UDP\Pbg̏ꍇ͂Ń|[gIPAhXݒ	*/
		if ( ( _es->sok[sok].mode & 0x0f ) == MR_UDP ) {
			aesWriteBlock( bs + Sn_DIPR  ,_es->sok[sok].ip ,4 );
			aesWriteWord( bs + Sn_DPORT ,_es->sok[sok].port );
		}
	}
}
