/*###########################################################################
#                                                                           #
#           	SPIo̓W[(}X^mode0p)                    #
#                                                                           #
#  {t@CCN[hOɈȉ̃}N`Ă           #
#  {t@CCN[hʒuɋC								#
#																			#
#  gp|[gDDR/PORT͎Oɐݒ肵Ă							#
#  MOSI : Ho   MISO : vAbv   : SCK = Lo                 #
#                                                                           #
# #define SPI_TYPE 2			// 0:soft 1:SPIport 2:USART0 3:USART1		#
#                                                                           #
# #define SPI_MOSI_PORT PORTD	// MOSIɊ蓖Ă|[g̏o̓WX^		#
# #define SPI_MOSI_BIT 1		// MOSIɊ蓖Ă|[g̃rbgԍ		#
#                                                                           #
# #define SPI_MISO_PIN PIND		// MISOɊ蓖Ă|[g̓̓WX^		#
# #define SPI_MISO_BIT 0		// MISOɊ蓖Ă|[g̃rbgԍ		#
#                                                                           #
# #define SPI_SCK_PORT PORTD	// SCKɊ蓖Ă|[g̏o̓WX^		#
# #define SPI_SCK_BIT 4			// SCKɊ蓖Ă|[g̃rbgԍ		#
#                                                                           #
###########################################################################*/
#ifndef __SPI_FUNC_H__
#define __SPI_FUNC_H__

#include <avr/io.h>

/*											*/
/* USART|[gڑ̃WX^`			*/
/*											*/
#ifndef SPI_TYPE
#error Do not forget to set SPI_TYPE
#endif

#if ( SPI_TYPE == 2 )
#define UBRR  ( UBRR0  )
#define UCSRA ( UCSR0A )
#define UDRE  ( UDRE0  )
#define UDR   ( UDR0   )
#define TXC   ( TXC0   )
#define RXC   ( RXC0   )

#elif ( SPI_TYPE == 3 )
#define UBRR  ( UBRR1  )
#define UCSRA ( UCSR1A )
#define UDRE  ( UDRE1  )
#define UDR   ( UDR1   )
#define TXC   ( TXC1   )
#define RXC   ( RXC1   )

#elif ( ( SPI_TYPE != 0 ) && ( SPI_TYPE != 1 ) )
#error Do not forget to set SPI_TYPE
#endif

/*											*/
/* SPINbNxݒ}N				*/
/*											*/
#if ( SPI_TYPE == 0 )
static uint8_t spiClockSpeed = 0;
#define SPI_LOW_SPEED()														\
{																			\
	spiClockSpeed = 100;													\
}
#define SPI_MID_SPEED()														\
{																			\
	spiClockSpeed = 8;														\
}
#define SPI_HI_SPEED()														\
{																			\
	spiClockSpeed = 0;														\
}

#elif ( SPI_TYPE == 1 )
#define SPI_LOW_SPEED()					/* F_CPU / 128	*/					\
{																			\
	SPCR = 0x53;															\
	SPSR = 0x00;															\
}
#define SPI_MID_SPEED()					/* F_CPU / 4	*/					\
{																			\
	SPCR = 0x50;															\
	SPSR = 0x00;															\
}
#define SPI_HI_SPEED()					/* F_CPU / 2	*/					\
{																			\
	SPCR = 0x50;															\
	SPSR = 0x01;															\
}
#else

#define SPI_LOW_SPEED()					/* F_CPU / 128	*/					\
{																			\
	UBRR = 63;																\
}
#define SPI_MID_SPEED()					/* F_CPU / 4	*/					\
{																			\
	UBRR = 1;																\
}
#define SPI_HI_SPEED()					/* F_CPU / 2	*/					\
{																			\
	UBRR = 0;																\
}
#endif

/*****************************************************************************
*								SPI
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void spiInit( void )
{
	#if ( SPI_TYPE == 2 )
		UCSR0B = _BV(RXEN0) | _BV(TXEN0);
		UCSR0C = 0xc0;
	#elif ( SPI_TYPE == 3 )
		UCSR1B = _BV(RXEN1) | _BV(TXEN1);
		UCSR1C = 0xc0;
	#endif

	SPI_LOW_SPEED();
}

/*****************************************************************************
*								SPI PoCgM
* Fuint8_t tx Mf[^
* ߒlFuint8_t    Mf[^
*****************************************************************************/
static uint8_t spiTransfer( uint8_t tx )
{
	/* \tgEGASPI[h(MODE0p)	*/
	#if ( SPI_TYPE == 0 )
		uint8_t rx = 0x00;
		uint8_t bit = 8;
		uint8_t n;

		while ( bit-- ) {

			rx <<= 1;									/* MISO 擾		*/
			if ( SPI_MISO_PIN & _BV(SPI_MISO_BIT) ) {
				rx |= 0x01;
			}

			if ( tx & 0x80 ) {							/* MOSI o		*/
				SPI_MOSI_PORT |=  _BV(SPI_MOSI_BIT);
			} else {
				SPI_MOSI_PORT &= ~_BV(SPI_MOSI_BIT);
			}
			tx <<= 1;

			SPI_SCK_PORT |= _BV(SPI_SCK_BIT);			/* SCK o			*/
			asm( "nop" );
			SPI_SCK_PORT &= ~_BV(SPI_SCK_BIT);

			n = spiClockSpeed;							/* KȃEGCg	*/
			while ( n-- ) {				
				asm( "nop" );
			}
		}

		return ( rx );

	/* SPI|[gڑ[h				*/
	#elif ( SPI_TYPE == 1 )
		SPDR = tx;							/* Mf[^WX^Zbg		*/
		while( !( SPSR & _BV(SPIF) ) );		/* Vtg҂				*/
		return ( SPDR );					/* Mf[^Ԃ				*/

	/* USART|[gڑ[h			*/
	#else
		while ( !( UCSRA & _BV(UDRE) ) );	/* Mf[^WX^󂫑҂	*/
		UDR = tx;							/* Mf[^WX^Zbg		*/
		while ( !( UCSRA & _BV(RXC) ) );	/* f[^M҂			*/
		return ( UDR );						/* Mf[^Ԃ				*/
	#endif
}

#endif
